package br.shmem.compiler;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

public class ReferenceModel extends AbstractTableModel {
    
    ReferenceDescriptor descriptor;
    
    public ReferenceModel(ReferenceDescriptor descriptor) {
        this.descriptor = descriptor;
    }
    
    public String getColumnName(int col) { 
        switch(col) {
            case 0: return "Name";
            case 1: return "Write";
            default: return null;
        }
    }
    public int getRowCount() { 
        return descriptor.getMethodsCount(); 
    }
    
    public int getColumnCount() { 
        return 2; 
    }
    
    public Object getValueAt(int row, int col) { 
        switch(col) {
            case 0: return descriptor.getName(row);
            case 1: return new Boolean(descriptor.isWrite(row));
            default: return null;
        }
    }
    public boolean isCellEditable(int row, int col) { 
        if(col == 1) {
            return true;
        }
        return false;
    }
    
    public void setValueAt(Object value, int row, int col) {
        if(col == 1) {
            boolean flag = false;
            if(value != null)
                flag = ((Boolean)value).booleanValue();
                
            descriptor.setWrite(row, flag);
            fireTableCellUpdated(row, col);
        }
    }
    
    public Class getColumnClass(int col) {
        switch(col) {
            case 0: return String.class;
            case 1: return Boolean.class;
            default: return null;
        }
    }
}
