package wumpus;

public class Environment {

	private boolean smells = false;
	private boolean windy = false;
	private boolean light = false;
	
	public Environment(Board board, int x, int y) {
		Square sq = board.getSquare(x, y-1); // NORTH
		if (!windy && sq.isHole()) windy = true;
		else if (!light && sq.isExit()) light = true;
		else if (!smells && sq.isOccupied()) smells = true;
		
		sq = board.getSquare(x, y+1); // SOUTH
		if (!windy && sq.isHole()) windy = true;
		else if (!light && sq.isExit()) light = true;
		else if (!smells && sq.isOccupied()) smells = true;
		
		sq = board.getSquare(x+1, y); // EAST
		if (!windy && sq.isHole()) windy = true;
		else if (!light && sq.isExit()) light = true;
		else if (!smells && sq.isOccupied()) smells = true;

		sq = board.getSquare(x-1, y); // WEST
		if (!windy && sq.isHole()) windy = true;
		else if (!light && sq.isExit()) light = true;
		else if (!smells && sq.isOccupied()) smells = true;
	}
	
	public boolean smells() {
		return smells;
	}
	
	public boolean windy() {
		return windy;
	}
	
	public boolean hasLight() {
		return light;
	}
}
