package wumpus;

public class Game {
	private boolean victory = false;
	private boolean death = false;
	private boolean started = false;
	private Board board;
	
	public Game(Board board) {
		this.board = board;
		board.setGame(this);
	}
	
	public Board getBoard() {
		return board;
	}
	
	public synchronized void startGame() {
		started = true;
		notifyAll();
	}
	
	public boolean isGameStarted() {
		return started;
	}
	
	public boolean isGameEnded() {
		return started && (victory || death);
	}
	
	public void setVictory() {
		victory = true;
	}
	
	public void setDeath() {
		death = true;
	}
	
}
