package wumpus;

import br.shmem.*;
import java.lang.reflect.*;

public class SquareReference extends SharedReference {
	
	private Method mGetGold;
	private Method mGetOccupant;

	public SquareReference(SharedMemory shmem, String globalName)
		throws IncompatibleProxyException
	{
		super(shmem, globalName);
		try {
			mGetGold = getDeclaredMethod("getGold", null);
			mGetOccupant = getDeclaredMethod("getOccupant", null);
		}
		catch (NoSuchMethodException e) {
			throw new IncompatibleProxyException(e.getMessage());
		}
	}
	
	public int getGold() 
		throws InvocationException
	{
		Integer result = (Integer) callMethod(mGetGold, null);
		return result.intValue();
	}
}
